//-----------------------------------------------------
//File: lcd_8bit.h
//Auth: ELECTRONIC ASSEMBLY JM
//DATE: 08-07-2012
//-----------------------------------------------------
#ifndef LCD8BIT_H
#define LCD8BIT_H

//#define DIP203_4
#define DIP203_6

//--- Port definitions for 8 bit port ---
#define RS 		p6_0
#define ddRS	pd6_0
#define RW		p6_1
#define ddRW	pd6_1
#define EN		p6_2
#define ddEN	pd6_2

#define DATA	p0
#define ddDATA	pd0

//--- Standard definitions for LCD ---
#define LCD_HOME_L1	0x80
#define LINE1	0
/*
//HD44780
#define LINE2	LINE1+0x40
#define LINE3	LINE1+0x14
#define	LINE4 	LINE2+0x14
*/
//KS0073/SSD1803
#define LINE2	LINE1+0x20
#define LINE3	LINE1+0x40
#define	LINE4 	LINE1+0x60

#define DISPLAY_ON 	0x04
#define DISPLAY_OFF 0x03
#define CURSOR_ON	0x02
#define CURSOR_OFF	0x05
#define BLINK_ON	0x01
#define BLINK_OFF	0x06

	

void initDispl(void);


void WriteChar		(char character);
void WriteString	(_far char * string);
void SetSymb 		(char add, char data);
void SetPostion		(char pos);
void DisplayOnOff	(char data);
void DefineCharacter(unsigned char postion, unsigned char *data);
void ClrDisplay		(void);
#define GETCURSORADDR()	CheckBusy();

//use the macro definitions to set symbols, parameter: true (blinkon) or false (blink off)
#ifdef DIP203_6
	#define SetSymbPHONE(x)		SetSymb(0x40,0x10+(x<<6))
	#define SetSymbBELL(x)		SetSymb(0x41,0x10+(x<<6))
	#define SetSymbLETTER(x)	SetSymb(0x42,0x10+(x<<6))
	#define SetSymbDOC(x)		SetSymb(0x43,0x10+(x<<6))
	#define SetSymbHOURGLASS(x)	SetSymb(0x44,0x10+(x<<6))
	#define SetSymbPC(x)		SetSymb(0x45,0x10+(x<<6))
	#define SetSymbFLOPPY(x)	SetSymb(0x46,0x10+(x<<6))
	#define SetSymbTHERM(x)		SetSymb(0x47,0x10+(x<<6))
	#define SetSymbCLOCK(x)		SetSymb(0x48,0x10+(x<<6))
	#define SetSymbSPEAKER(x)	SetSymb(0x49,0x10+(x<<6))
	#define SetSymbARROWL(x)	SetSymb(0x4A,0x10+(x<<6))
	#define SetSymbARROWR(x)	SetSymb(0x4B,0x10+(x<<6))
	#define SetSymbARROWU(x)	SetSymb(0x4C,0x10+(x<<6))
	#define SetSymbARROWLD(x)	SetSymb(0x4D,0x10+(x<<6))
	#define SetSymbINFO(x)		SetSymb(0x4E,0x10+(x<<6))
	#define SetSymbBAT0(x)		SetSymb(0x4F,0x10+(x<<6))
	#define SetSymbBAT1(x)		SetSymb(0x4F,0x18+(x<<6))
	#define SetSymbBAT2(x)		SetSymb(0x4F,0x1C+(x<<6))
	#define SetSymbBAT3(x)		SetSymb(0x4F,0x1E+(x<<6))
	#define SetSymbBAT4(x)		SetSymb(0x4F,0x1F+(x<<6))
	#define SetSymbALL(x)		SetSymb(0x40,0x3F+(x<<6))

	//use the macro definitions to clear symbols
	#define ClrSymbPHONE()		SetSymb(0x40,0x00)
	#define ClrSymbBELL()		SetSymb(0x41,0x00)
	#define ClrSymbLETTER()	SetSymb(0x42,0x00)
	#define ClrSymbDOC()		SetSymb(0x43,0x00)
	#define ClrSymbHOURGLASS()	SetSymb(0x44,0x00)
	#define ClrSymbPC()		SetSymb(0x45,0x00)
	#define ClrSymbFLOPPY()	SetSymb(0x46,0x00)
	#define ClrSymbTHERM()		SetSymb(0x47,0x00)
	#define ClrSymbCLOCK()		SetSymb(0x48,0x00)
	#define ClrSymbSPEAKER()	SetSymb(0x49,0x00)
	#define ClrSymbARROWL()	SetSymb(0x4A,0x00)
	#define ClrSymbARROWR()	SetSymb(0x4B,0x00)
	#define ClrSymbARROWU()	SetSymb(0x4C,0x00)
	#define ClrSymbARROWLD()	SetSymb(0x4D,0x00)
	#define ClrSymbINFO()		SetSymb(0x4E,0x00)
	#define ClrSymbBAT()		SetSymb(0x4F,0x00)
	#define ClrSymbALL()		SetSymb(0x40,0xFF);
#endif


//Normally you don't need these functions outside this module
static void WriteIns		(char ins);
static void WriteData		(char data);

unsigned char CheckBusy		(void);

#endif